> ## Documentation Index
> Fetch the complete documentation index at: https://docs.stigg.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get entitlements state

> Retrieves the effective entitlements for a customer or resource, including feature and credit entitlements.

**Warning:** This REST API endpoint lacks built-in client-side caching, fallback mechanisms, and low-latency guarantees. It is not recommended for hot-path entitlement checks. For production use, consider using the Stigg Node Server SDK with caching or the Sidecar for low-latency cached responses.



## OpenAPI

````yaml https://app.stainless.com/api/spec/documented/stigg/openapi.documented.yml get /api/v1/customers/{id}/entitlements
openapi: 3.0.0
info:
  title: Stigg API
  description: Stigg API documentation
  version: 7.93.1
  contact: {}
servers:
  - url: https://api.stigg.io
    description: Production
security:
  - ApiKeyAuth: []
tags:
  - name: Customers
    description: Operations related to customers
  - name: Subscriptions
    description: Operations related to subscriptions
  - name: Coupons
    description: Operations related to coupons
  - name: Bulk Import
    description: Operations related to import of customers and subscriptions
  - name: Usage
    description: Operations related to usage & metering
  - name: Promotional Entitlements
    description: Operations related to promotional entitlements
  - name: Products
    description: Operations related to products
  - name: Features
    description: Operations related to features
  - name: Addons
    description: Operations related to addons
  - name: Plans
    description: Operations related to plans
  - name: Credit grants
    description: Operations related to credit grants
  - name: Credit ledger
    description: Operations related to credit ledger
  - name: Custom currencies
    description: Operations related to custom currencies
paths:
  /api/v1/customers/{id}/entitlements:
    get:
      tags:
        - Entitlements
      summary: Get entitlements state
      description: >-
        Retrieves the effective entitlements for a customer or resource,
        including feature and credit entitlements.


        **Warning:** This REST API endpoint lacks built-in client-side caching,
        fallback mechanisms, and low-latency guarantees. It is not recommended
        for hot-path entitlement checks. For production use, consider using the
        Stigg Node Server SDK with caching or the Sidecar for low-latency cached
        responses.
      operationId: EntitlementsController_getEntitlementsState
      parameters:
        - name: id
          required: true
          in: path
          description: The unique identifier of the entity
          schema:
            minLength: 1
            maxLength: 255
            type: string
        - name: resourceId
          required: false
          in: query
          description: Resource ID to scope entitlements to a specific resource
          schema:
            maxLength: 255
            type: string
        - name: X-ACCOUNT-ID
          in: header
          description: >-
            Account ID — optional when authenticating with a user JWT (Bearer
            token); falls back to the user's first membership. Ignored for
            API-key auth.
          required: false
          schema:
            type: string
        - name: X-ENVIRONMENT-ID
          in: header
          description: >-
            Environment ID — required when authenticating with a user JWT
            (Bearer token) on environment-scoped endpoints. Ignored for API-key
            auth (env is intrinsic to the key).
          required: false
          schema:
            type: string
      responses:
        '200':
          description: >-
            The entitlements state including feature and credit entitlements,
            and an optional access denied reason.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/EntitlementsStateResponseDto'
              examples:
                default:
                  value:
                    data:
                      entitlements:
                        - isGranted: true
                          type: FEATURE
                          accessDeniedReason: null
                          feature:
                            id: feature-api-calls
                            displayName: API Calls
                            featureType: NUMBER
                            featureStatus: ACTIVE
                          usageLimit: 10000
                          hasUnlimitedUsage: false
                          resetPeriod: MONTH
                          currentUsage: 2500
                        - isGranted: true
                          type: FEATURE
                          accessDeniedReason: null
                          feature:
                            id: feature-sso
                            displayName: Single Sign-On
                            featureType: BOOLEAN
                            featureStatus: ACTIVE
                      accessDeniedReason: null
        '400':
          description: bad request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadInputErrorResponseDto'
        '401':
          description: User is not authenticated.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/UnauthenticatedErrorResponseDto'
        '403':
          description: User is not allowed to access this resource.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ForbiddenErrorResponseDto'
        '404':
          description: Entitlements not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFoundErrorResponseDto'
        '429':
          description: Too many requests.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequestsErrorResponseDto'
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Stigg from '@stigg/typescript';


            const client = new Stigg({
              apiKey: process.env['STIGG_API_KEY'], // This is the default and can be omitted
            });


            const response = await
            client.v1.customers.retrieveEntitlements('x');


            console.log(response.data);
        - lang: Python
          source: |-
            import os
            from stigg import Stigg

            client = Stigg(
                api_key=os.environ.get("STIGG_API_KEY"),  # This is the default and can be omitted
            )
            response = client.v1.customers.retrieve_entitlements(
                id="x",
            )
            print(response.data)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/stiggio/stigg-go\"\n\t\"github.com/stiggio/stigg-go/option\"\n)\n\nfunc main() {\n\tclient := stigg.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tresponse, err := client.V1.Customers.GetEntitlements(\n\t\tcontext.TODO(),\n\t\t\"x\",\n\t\tstigg.V1CustomerGetEntitlementsParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", response.Data)\n}\n"
        - lang: Java
          source: >-
            package io.stigg.example;


            import io.stigg.client.StiggClient;

            import io.stigg.client.okhttp.StiggOkHttpClient;

            import
            io.stigg.models.v1.customers.CustomerRetrieveEntitlementsParams;

            import
            io.stigg.models.v1.customers.CustomerRetrieveEntitlementsResponse;


            public final class Main {
                private Main() {}

                public static void main(String[] args) {
                    StiggClient client = StiggOkHttpClient.fromEnv();

                    CustomerRetrieveEntitlementsResponse response = client.v1().customers().retrieveEntitlements("x");
                }
            }
        - lang: Ruby
          source: |-
            require "stigg"

            stigg = Stigg::Client.new(api_key: "My API Key")

            response = stigg.v1.customers.retrieve_entitlements("x")

            puts(response)
        - lang: C#
          source: >-
            using System;

            using Stigg.Client;

            using Stigg.Client.Models.V1.Customers;


            StiggClient client = new();


            CustomerRetrieveEntitlementsParams parameters = new() { ID = "x" };


            var response = await
            client.V1.Customers.RetrieveEntitlements(parameters);


            Console.WriteLine(response);
        - lang: CLI
          source: |-
            stigg v1:customers retrieve-entitlements \
              --api-key 'My API Key' \
              --id x
components:
  schemas:
    EntitlementsStateResponseDto:
      type: object
      properties:
        data:
          type: object
          properties:
            entitlements:
              type: array
              items:
                discriminator:
                  propertyName: type
                oneOf:
                  - type: object
                    properties:
                      isGranted:
                        type: boolean
                      type:
                        type: string
                        enum:
                          - FEATURE
                      accessDeniedReason:
                        type: string
                        enum:
                          - FeatureNotFound
                          - CustomerNotFound
                          - CustomerIsArchived
                          - CustomerResourceNotFound
                          - NoActiveSubscription
                          - NoFeatureEntitlementInSubscription
                          - RequestedUsageExceedingLimit
                          - RequestedValuesMismatch
                          - BudgetExceeded
                          - Unknown
                          - FeatureTypeMismatch
                          - Revoked
                          - InsufficientCredits
                          - EntitlementNotFound
                        nullable: true
                      feature:
                        type: object
                        properties:
                          id:
                            type: string
                            maxLength: 255
                            description: The unique reference ID of the entitlement.
                          displayName:
                            type: string
                            maxLength: 255
                            description: >-
                              The human-readable name of the entitlement, shown
                              in UI elements.
                          featureType:
                            type: string
                            enum:
                              - BOOLEAN
                              - NUMBER
                              - ENUM
                            description: >-
                              The type of feature associated with the
                              entitlement.
                          featureStatus:
                            type: string
                            enum:
                              - NEW
                              - SUSPENDED
                              - ACTIVE
                            description: The current status of the feature.
                        required:
                          - id
                          - displayName
                          - featureType
                          - featureStatus
                      usageLimit:
                        type: number
                        minimum: 0
                        nullable: true
                      hasUnlimitedUsage:
                        type: boolean
                      resetPeriod:
                        type: string
                        enum:
                          - YEAR
                          - MONTH
                          - WEEK
                          - DAY
                          - HOUR
                        nullable: true
                      currentUsage:
                        type: number
                        minimum: 0
                      usagePeriodAnchor:
                        type: string
                        format: date-time
                        description: >-
                          The anchor for calculating the usage period for
                          metered entitlements with a reset period configured
                      usagePeriodStart:
                        type: string
                        format: date-time
                        description: >-
                          The start date of the usage period for metered
                          entitlements with a reset period configured
                      usagePeriodEnd:
                        type: string
                        format: date-time
                        description: >-
                          The end date of the usage period for metered
                          entitlements with a reset period configured
                      entitlementUpdatedAt:
                        type: string
                        format: date-time
                        description: >-
                          Timestamp of the last update to the entitlement grant
                          or configuration.
                      validUntil:
                        type: string
                        format: date-time
                        description: The next time the entitlement should be recalculated
                    required:
                      - isGranted
                      - type
                      - accessDeniedReason
                  - type: object
                    properties:
                      isGranted:
                        type: boolean
                      type:
                        type: string
                        enum:
                          - CREDIT
                      accessDeniedReason:
                        type: string
                        enum:
                          - FeatureNotFound
                          - CustomerNotFound
                          - CustomerIsArchived
                          - CustomerResourceNotFound
                          - NoActiveSubscription
                          - NoFeatureEntitlementInSubscription
                          - RequestedUsageExceedingLimit
                          - RequestedValuesMismatch
                          - BudgetExceeded
                          - Unknown
                          - FeatureTypeMismatch
                          - Revoked
                          - InsufficientCredits
                          - EntitlementNotFound
                        nullable: true
                      usageLimit:
                        type: number
                        minimum: 0
                      currentUsage:
                        type: number
                        minimum: 0
                      usageUpdatedAt:
                        type: string
                        format: date-time
                        description: Timestamp of the last update to the credit usage.
                      currency:
                        type: object
                        properties:
                          currencyId:
                            type: string
                            maxLength: 255
                            description: The unique identifier of the custom currency.
                          displayName:
                            type: string
                            maxLength: 255
                            description: The display name of the currency.
                          description:
                            type: string
                            maxLength: 255
                            description: A description of the currency.
                            nullable: true
                          unitSingular:
                            type: string
                            maxLength: 255
                            description: The singular form of the currency unit.
                            nullable: true
                          unitPlural:
                            type: string
                            maxLength: 255
                            description: The plural form of the currency unit.
                            nullable: true
                          metadata:
                            type: object
                            additionalProperties:
                              type: string
                            description: Additional metadata associated with the currency.
                            nullable: true
                        required:
                          - currencyId
                          - displayName
                        description: The currency associated with a credit entitlement.
                      entitlementUpdatedAt:
                        type: string
                        format: date-time
                        description: >-
                          Timestamp of the last update to the entitlement grant
                          or configuration.
                      validUntil:
                        type: string
                        format: date-time
                        description: The next time the entitlement should be recalculated
                      usagePeriodEnd:
                        type: string
                        format: date-time
                        description: >-
                          The end date of the current billing period for
                          recurring credit grants.
                    required:
                      - isGranted
                      - type
                      - accessDeniedReason
                      - usageLimit
                      - currentUsage
                      - usageUpdatedAt
                      - currency
              description: List of effective feature and credit entitlements
            accessDeniedReason:
              type: string
              enum:
                - CustomerNotFound
                - NoActiveSubscription
                - CustomerIsArchived
              nullable: true
              description: Reason why entitlements access was denied, if applicable
          required:
            - entitlements
            - accessDeniedReason
          title: CustomerEntitlementsState
          description: The effective entitlements state for a customer or resource.
      required:
        - data
      title: Response
      description: Response object
    BadInputErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - BadUserInput
            - DuplicateIntegrationNotAllowed
            - EntityIsArchivedError
            - IntegrityViolation
            - FreePlanCantHaveCompatiblePackageGroupError
            - SubscriptionMustHaveSinglePlanError
            - AddonIsCompatibleWithPlan
            - AddonIsCompatibleWithGroup
            - DuplicateAddonProvisionedError
            - ScheduledMigrationAlreadyExistsError
            - SubscriptionAlreadyOnLatestPlan
            - EntityIdDifferentFromRefIdError
            - UnsupportedFeatureType
            - UnsupportedVendorIdentifier
            - UnsupportedSubscriptionScheduleType
            - InvalidEntitlementResetPeriod
            - IncompatibleSubscriptionAddon
            - UnPublishedPackage
            - MeteringNotAvailableForFeatureType
            - AuthCustomerMismatch
            - AuthCustomerReadonly
            - FetchAllCountriesPricesNotAllowed
            - MemberInvitationError
            - PlansCircularDependencyError
            - NoFeatureEntitlementInSubscription
            - CheckoutIsNotSupported
            - UnsupportedParameter
            - PricingModelNotSupportedByBillingIntegration
            - BillingIntegrationMissing
            - BillingIntegrationAlreadyExistsError
            - InvalidMemberDelete
            - PackageAlreadyPublished
            - DraftPlanCantBeArchived
            - DraftAddonCantBeArchived
            - PlanWithChildCantBeDeleted
            - PlanCannotBePublishWhenBasePlanIsDraft
            - PlanCannotBePublishWhenCompatibleAddonIsDraft
            - PlanIsUsedAsDefaultStartPlan
            - PlanIsUsedAsDowngradePlan
            - InvalidAddressError
            - InvalidQuantity
            - BillingPeriodMissingError
            - DowngradeBillingPeriodNotSupportedError
            - CustomerAlreadyUsesCouponError
            - CustomerAlreadyHaveCustomerCoupon
            - SubscriptionAlreadyCanceledOrExpired
            - TrialMustBeCancelledImmediately
            - SubscriptionDoesNotHaveBillingPeriod
            - InvalidCancellationDate
            - FailedToImportCustomer
            - FailedToImportSubscriptions
            - PackagePricingTypeNotSet
            - InvalidSubscriptionStatus
            - InvalidArgumentError
            - EditAllowedOnDraftPackageOnlyError
            - ResyncAlreadyInProgress
            - ArchivedCouponCantBeApplied
            - ImportAlreadyInProgress
            - AddonHasToHavePriceError
            - SelectedBillingModelDoesntMatchImportedItemError
            - CannotArchiveProductError
            - CannotUnarchiveProductError
            - CannotDeleteCustomerError
            - CannotRemovePaymentMethodFromCustomerError
            - CannotDeleteFeatureError
            - CannotArchiveFeatureError
            - InvalidUpdatePriceUnitAmountError
            - ExperimentAlreadyRunning
            - ExperimentStatusError
            - OperationNotAllowedDuringInProgressExperiment
            - EntitlementsMustBelongToSamePackage
            - CanNotUpdateEntitlementsFeatureGroup
            - MeterMustBeAssociatedToMeteredFeature
            - CannotEditPackageInNonDraftMode
            - CannotAddOverrideEntitlementToPlan
            - MissingEntityIdError
            - NoProductsAvailable
            - PromotionCodeNotForCustomer
            - PromotionCodeNotActive
            - PromotionCodeMaxRedemptionsReached
            - PromotionCodeMinimumAmountNotReached
            - PromotionCodeCustomerNotFirstPurchase
            - AddonWithDraftCannotBeDeletedError
            - CannotReportUsageForEntitlementWithMeterError
            - RecalculateEntitlementsError
            - ImportSubscriptionsBulkError
            - InvalidMetadataError
            - CannotUpsertToPackageThatHasDraft
            - IntegrationValidationError
            - AwsMarketplaceIntegrationValidationError
            - AwsMarketplaceIntegrationError
            - DataExportIntegrationError
            - HubspotIntegrationError
            - DuplicateProductValidationError
            - AmountTooLarge
            - CustomerHasNoEmailAddress
            - MergeEnvironmentValidationError
            - EntitlementLimitExceededError
            - EntitlementUsageOutOfRangeError
            - UsageMeasurementDiffOutOfRangeError
            - AddonQuantityExceedsLimitError
            - AddonDependencyMissingError
            - PackageGroupMinItemsError
            - CannotUpdateUnitTransformationError
            - SingleSubscriptionCantBeAutoCancellationTargetError
            - MultiSubscriptionCantBeAutoCancellationSourceError
            - ChangingPayingCustomerIsNotSupportedError
            - RequiredSsoAuthenticationError
            - InvalidDoggoSignatureError
            - InvalidReceivedSignatureError
            - CannotDeleteDefaultIntegration
            - CannotChangeBillingIntegration
            - FailedToResolveBillingIntegration
            - WorkflowTriggerNotFound
            - DeprecatedEstimateSubscriptionError
            - FeatureConfigurationExceededLimitError
            - FeatureNotBelongToFeatureGroupError
            - FeatureGroupMissingFeaturesError
            - VersionExceedsMaxValueError
            - CannotUpdateExpireAtForExpiredCreditGrantError
            - ExpireAtMustBeLaterThanEffectiveAtError
            - OfferAlreadyExists
            - DraftAlreadyExists
            - CreditGrantAlreadyVoided
            - CreditGrantCannotBeVoided
            - InvalidTaxId
            - ObjectAlreadyBeingUsedByAnotherRequestError
            - TooManySubscriptionsPerCustomer
            - TooManyCustomCurrencies
            - StripeError
            - SchedulingAtEndOfBillingPeriod
            - ApiKeyExpired
            - ApiKeyHasExpiry
          nullable: true
      required:
        - message
        - code
    UnauthenticatedErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - Unauthenticated
          nullable: true
      required:
        - message
        - code
    ForbiddenErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - IdentityForbidden
            - AccessDeniedError
            - NoFeatureEntitlementError
            - GovernanceNotEnabled
          nullable: true
      required:
        - message
        - code
    NotFoundErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - CustomerNotFound
            - CustomCurrencyNotFound
            - CreditGrantNotFound
            - MemberNotFound
            - PackageGroupNotFound
            - AddonNotFound
            - AddonsNotFound
            - EnvironmentMissing
            - IntegrationNotFound
            - VendorIsNotSupported
            - CouponNotFound
            - FutureUpdateNotFound
            - CustomerNoBillingId
            - SubscriptionNoBillingId
            - StripeCustomerIsDeleted
            - InitStripePaymentMethodError
            - PreparePaymentMethodFormError
            - AccountNotFoundError
            - ExperimentNotFoundError
            - NoDraftOfferFound
            - PromotionCodeNotFound
            - FailedToCreateCheckoutSessionError
            - PaymentMethodNotFoundError
            - ProductNotFoundError
            - ProductNotPublishedError
            - MissingBillingInvoiceError
            - BillingInvoiceStatusError
            - FeatureGroupNotFoundError
            - CannotArchiveFeatureGroupError
            - OfferNotFound
            - CustomerResourceNotFound
            - FeatureNotFound
            - PriceNotFound
            - NoActiveSubscriptionForCustomer
            - PlanNotFound
            - PromotionalEntitlementNotFoundError
            - SubscriptionNotFound
            - ApiKeyNotFound
          nullable: true
      required:
        - message
        - code
    TooManyRequestsErrorResponseDto:
      type: object
      properties:
        message:
          type: string
        code:
          type: string
          enum:
            - RateLimitExceeded
          nullable: true
      required:
        - message
        - code
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: X-API-KEY
      description: Server API Key

````